// npbd.cpp - copied from the original NewpixbOTTification but not actually used
// The online interface for the NewpixbOTTification and 403fication software
// 16.01.2015
// 
// Copyright (C) 2014  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 

// Requires cgilib (http://www.infodrom.org/projects/cgilib/)
// line 146 of cgi.h must be changed from:
// extern }
// to:
// }

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/wait.h>
#include <sys/stat.h>

#define WGET_PATH  "/usr/bin/wget"
#define NPB_PATH   "/eizm/pro/ong1/npb"
#define MEG_PATH   "./403"
#define RM_PATH    "/bin/rm"
#define LOG_PATH   "/eizm/log/npb/npb.log"
#define LOG_PATH2  "/eizm/log/npb/403.log"
#define USERAGENT  "NewpixbOTTification\x20(1190.bicyclesonthemoon.dnsd.info/npb/npb.htm)"
#define USERAGENT2 "403fication\x20(1190.bicyclesonthemoon.dnsd.info/npb/403.htm)"
#define MSTD_PATH  "/pro/npb/mpb.png"
#define MSTD_PATH2 "/pro/npb/503.png"

int main (int argc, char *argv[]);
void mustard(int mustard);

FILE *pix;
unsigned char buf[1024];
char url[1024];
char path[256];
char method[256];
s_cgi *cgi;
int t;
pid_t sub;
struct stat st;
unsigned long p;
unsigned short q;
char **up;
bool meg=false;

int main (int argc, char *argv[])
{
	cgi=cgiInit();
	
	sprintf(path,"%s",(getenv("PATH_INFO")!=NULL)?(getenv("PATH_INFO")):"");
	if(strcmp(path,"/403")==0)
	{
		meg=true;
		//mustard(0);
	}
	
	up=cgiGetFiles(cgi);
	if (up)
	{
		sprintf(path,"%s",cgiGetFile(cgi,up[0])->tmpfile);
		sprintf(url,"%s",cgiGetFile(cgi,up[0])->filename);
	}
	else
	{
		sprintf(url,"%s",(cgiGetValue(cgi,"inpix")!=NULL)?(cgiGetValue(cgi,"inpix")):"");
		sprintf(path,"/var/tmp/%lu",(unsigned long)getpid());
		
		//Why is  there no spawnl() in linux?
		sub=fork();
		if(sub==0)
		{
			t=execl(WGET_PATH,WGET_PATH,"-q","-t","2","-U",meg?USERAGENT2:USERAGENT,"-O",path,url,(char *)0);
			exit(t);
		}
		waitpid(sub,&t,0);
		if(t)mustard(t);
	}
	
	sub=fork();
	if(sub==0)
	{
		t=execl(meg?MEG_PATH:NPB_PATH,meg?MEG_PATH:NPB_PATH,path,path,"q",(char *)0);
		exit(t);
	}
	waitpid(sub,&t,0);
	if(t)mustard(t);
	
	pix=fopen(path,"rb");
	if(pix==NULL)
		mustard(123);
	fstat(fileno(pix),&st);
	p=st.st_size/1024;
	q=st.st_size%1024;
	
	printf("Content-Length: %lu\n",(unsigned long)(st.st_size));
	printf("Content-type: image/png\n\n");
	for(unsigned long i=0;i<p;++i)
	{
		fread(buf,1,1024,pix);
		fwrite(buf,1,1024,stdout);
	}
	if(q!=0)
	{
		fread(buf,1,q,pix);
		fwrite(buf,1,q,stdout);
	}
	fclose(pix);
	fflush(stdout);
	mustard(0);//no mustard
}

void mustard(int mustard)
{
	if(mustard)
	{
		cgiRedirect(meg?MSTD_PATH2:MSTD_PATH);
	}
	sub=fork();
	if(sub==0)
	{
		t=execl(RM_PATH,RM_PATH,"-f",path,(char *)0);
		exit(t);
	}
	waitpid(sub,&t,0);
	// pix=fopen(meg?LOG_PATH2:LOG_PATH,"at");
	// if(pix!=NULL)
	// {
		// fprintf(pix,"%x %s\n",mustard,url);
		// fclose(pix);
	// }
	exit(mustard);
}