// relink.c (1190.bicyclesonthemoon.info/ongoing.png (old))
// redirect to the latest frame
// 06.04.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define ONG_STATE_PATH "/eizm/data/aftertime/bftf/ongstate"
#define RELINK_PATH    "/ongframe.png?f=%hu"

#include <cgi.h>
#include <stdio.h>

s_cgi *cgi;

int main (int argc, char *argv[])
{
	FILE *file;
	char relinkPath[256];
	unsigned short ongFrame;
	unsigned char ongState;
	
	cgi=cgiInit();
	
	file=fopen(ONG_STATE_PATH,"rt");
	if(file!=NULL)
	{
		fscanf(file,"%hhu %hu",&ongState,&ongFrame);
		fclose(file);
	}
	else
	{
		ongState=0;
		ongFrame=0;
	}
	
	if(ongState==1)
	{
		file=fopen(ONG_STATE_PATH,"wt");
		if(file!=NULL)
		{
			fprintf(file,"2 %hu",ongFrame);
			fclose(file);
		}
	}
	
	sprintf(relinkPath,RELINK_PATH,(unsigned short)ongFrame);
	cgiRedirect(relinkPath);
	
	return 0;
}