// view.c (1190.bicyclesonthemoon.info/ongoing.png(new) 1190.bicyclesonthemoon.info/ongframe.png)
// the frame
// 06.04.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define ONG_STATE_PATH "/eizm/data/aftertime/bftf/ongstate"
#define CFRT_PATH      "/ongoing/cfrt.png"
#define FRAME_PRINTF   "/ongoing/bftf-%04hu.png"


#include <cgi.h>
#include <stdio.h>
#include <sys/stat.h>

s_cgi *cgi;

int main (int argc, char *argv[]);
// int sendfile(char *path);

int main (int argc, char *argv[])
{
	FILE *file;
	char *value;
	char framePath[256];
	unsigned short cgiFrame, ongFrame;
	unsigned char ongState;
	
	cgi=cgiInit();
	
	file=fopen(ONG_STATE_PATH,"rt");
	if(file==NULL)
	{
		cgiRedirect(CFRT_PATH);
		return 1;
	}
	fscanf(file,"%hhu %hu",&ongState,&ongFrame);
	fclose(file);
	
	value=cgiGetValue(cgi,"f");
	if(value!=NULL)
		sscanf(value,"%hu",&cgiFrame);
	else
		cgiFrame=ongFrame;
	
	if(ongState==0||cgiFrame>ongFrame)
	{
		cgiRedirect(CFRT_PATH);
		return 0;
	}
	if(cgiFrame==ongFrame&&ongState==1&&cgiGetValue(cgi,"n")==NULL)
	{
		file=fopen(ONG_STATE_PATH,"wt");
		if(file!=NULL)
		{
			fprintf(file,"2 %hu",ongFrame);
			fclose(file);
		}
	}
	
	sprintf(framePath,FRAME_PRINTF,cgiFrame);
	cgiRedirect(framePath);
	return 0;
	// return sendfile(framePath);
}

/*int sendfile(char *path)
{
	unsigned long p,i;
	unsigned short q;
	FILE *file;
	struct stat st;
	unsigned char buf[1024];
	
	file=fopen(path,"rb");
	if(file==NULL)
		return 1;
	fstat(fileno(file),&st);
	p=st.st_size/1024;
	q=st.st_size%1024;
	
	printf("Content-Length: %lu\n",(unsigned long)(st.st_size));
	printf("Content-type: image/png\n\n");
	
	for(i=0;i<p;++i)
	{
		fread(buf,1,1024,file);
		fwrite(buf,1,1024,stdout);
	}
	if(q!=0)
	{
		fread(buf,1,q,file);
		fwrite(buf,1,q,stdout);
	}
	fclose(file);
	return 0;
}*/