#// findlatest.awk
#// find the latest page and number of posts.
#// 14.08.2014
#// 
#// Copyright (C) 2014  Balthasar Szczepański
#// 
#// This program is free software: you can redistribute it and/or modify
#// it under the terms of the GNU Affero General Public License as
#// published by the Free Software Foundation, either version 3 of the
#// License, or (at your option) any later version.
#// 
#// This program is distributed in the hope that it will be useful,
#// but WITHOUT ANY WARRANTY; without even the implied warranty of
#// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#// GNU Affero General Public License for more details.
#// 
#// You should have received a copy of the GNU Affero General Public License
#// along with this program.  If not, see <http://www.gnu.org/licenses/>.


BEGIN {
	a=1;
};
{
	if (posts== "")
	{
		for(i=1;i<=NF;i++)
		{
			if(tolower($i) ~ /posts/)
				posts=$(i-1)
		}
	}
	else 	if (tolower($0) ~ /page/)
	{
		gsub(/<[^>]*>/," ",$0)
		for(i=1;i<=NF;i++)
		{
			if((tolower($i) ~ /page/) && (tolower($(i+2)) ~ /of/))
			{
				print $(i+3) " " posts >outfile
				a=0;
				exit a;
			}
		}
	}
};
END {
	exit a
}
