// spoiler.c (1190.bicyclesonthemoon.info/spoiler)
// main page redundaspoiler
// 16.08.2015
// 
// Copyright (C) 2014  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define REDBUTTON 32

#include <cgi.h>
#include <stdio.h>

s_cgi *cgi;

int main (int argc, char *argv[])
{
	char *value;
	unsigned short n;
	unsigned char open;
	unsigned char discovered;
	
	cgi=cgiInit();
	
	value=cgiGetValue(cgi,"n");
	if(value!=NULL)	
		sscanf(value,"%hu",&n);
	else
		n=0;
	
	open=((cgiGetValue(cgi,"o")!=NULL)?1:0);
	discovered=((cgiGetValue(cgi,"d")!=NULL)?1:0);
	
	printf("Content-type: text/html\n\n");
	
	fputs("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">\n",stdout);
	fputs("<html lang=\"en\"><head>\n",stdout);
	fputs("<title>xkcd 1190: \"Time\" &bull; Bicycles on the Moon</title>\n",stdout);
	fputs("<meta http-equiv=\"Content-type\" content=\"text/html; charset=iso-8859-2\">\n",stdout);
	fputs("<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">\n",stdout);
	fputs("<link rel=\"stylesheet\" href=\"/css/botm.css\">\n",stdout);
	fputs("</head><body>\n",stdout);
	fputs("Hi, I'm balthasar_s and this is<br>\n",stdout);
	fputs("<img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\"><br><br>\n",stdout);
	fputs("Some things related to the <a href=\"http://wiki.chirpingmustard.com\">Time</a> thread on the xkcd Fora are here.\n",stdout);
	fputs("<ul>\n",stdout);
	fputs("<li><a href=\"/ott/\">The OTT mirror</a><ul><li><a href=\"/ottmirror/\">Source and instructions</a></li></ul></li>\n",stdout);
	if(discovered)
		fputs("<li><a href=\"/ongoing.htm\">ONGoing story</a></li>\n<ul><li><a href=\"/ongmeta.htm\">The discovery</a></li><li><a href=\"/generator\">Object generator online</a></li>\n<li><a href=\"/ct-if\">Chronotransponder test interface</a></li></ul>\n",stdout);
	fputs("<li><a href=\"/aftertime\">time after Time</a><ul>\n",stdout);
	fputs("<li><a href=\"/aftertime/viewer?story=t1i\"><span class=\"ni\">The viewer</a></li>\n",stdout);
	fputs("<li><a href=\"/silentbot/list\">The Silent Chronotransponder</a></li></ul></li>\n",stdout);
	fputs("<li>Auto-manip and enhance<ul><li><a href=\"/pro/npb/npb.htm\">NewpixbOTTification</a></li>\n",stdout);
	fputs("<li><a href=\"/pro/npb/403.htm\">403fication</a></li>\n",stdout);
	fputs("<li><a href=\"/pro/bluenh/bluenh.htm\">Bluenhancement</a></li>\n",stdout);
	fputs("<li><a href=\"/pro/nofading/nofading.htm\">Un-fading</a></li>\n",stdout);
	fputs("<li><a href=\"/pro/insertframe/insertframe.htm\">Hidden frames</a></li></ul></li>\n",stdout);
	fputs("<li><a href=\"/script\">Userscripts</a></li>\n",stdout);
	fputs("<li><a href=\"/ongtext?b=on\">ONGtext generator</a></li>\n",stdout);
	fputs("<li>Bots<ul>\n<li><a href=\"/bothasar_s/\">bothasar_s</a></li>\n",stdout);
	fputs("<li><a href=\"/bothasar_t/\">bothasar_t</a></li>\n",stdout);
	fputs("<li><a href=\"/bothasar_p/\">bothasar_p</a></li>\n",stdout);
	fputs("<li>lmjbot</li>\n",stdout);
	fputs("<li><a href=\"/silentbot/\">SilentBot</a></li>\n</ul></li>\n",stdout);
	fputs("<li><a href=\"/staf/\">SilentTimer action figure</a></li>\n",stdout);
	fputs("<li><a href=\"/mrobsniped/\">mr<img src=\"/img/mrob27.gif\" alt=\"o\">bdex decoding</a></li>\n",stdout);
	fputs("</ul>\n",stdout);
	fputs("Redundant:<br>\n",stdout);
	fputs("<div style=\"margin:20px; margin-top:5px\">\n",stdout);
	printf("<form method=\"post\" action=\"/redundant?spoiler=%s\">\n",open?"show":"hide");
	printf("<input type=\"hidden\" name=\"n\" value=\"%hu\">\n",n+1);
	if(discovered)
		fputs("<input type=\"hidden\" name=\"d\" value=\"1\">\n",stdout);
	printf("<b>Spoiler: </b><input class=\"pk\" type=\"submit\" value=\"%s\"><br>\n",open?"Show":"Hide");
	
	if(!open)
	{
		fputs("<input type=\"hidden\" name=\"o\" value=\"1\">\n",stdout);
		
		if(n==REDBUTTON)
		{
			fputs("</form>\n",stdout);
			fputs("<form method=\"get\" action=\"/click\"><br>\n",stdout);
			fputs("N = <input class=\"pt\" type=\"text\" name=\"n\" size=\"3\"><br>\n",stdout);
			fputs("This button was supposed to be red: <input class=\"pk\" type=\"submit\" value=\"DON'T CLICK!\">\n",stdout);
			fputs("</form><br>\n",stdout);
			fputs("<form method=\"get\" action=\"/pro/bluenh/nh.png\"><br>\n",stdout);
			fputs("Also, enhance: <input class=\"pt\" type=\"text\" name=\"i\" size=\"3\"> <input class=\"pk\" type=\"submit\" value=\"ENHANCE!\">\n",stdout);
		}
		else
		{
			fputs("<img src=\"/img/redunbot.jpg\" alt=\"I told U was redundant. Y U no believe me?\" border=\"0\"><br><br>\n",stdout);
			fputs("<img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"1\"><br>\n",stdout);
			printf("botmlogo2.png (1.24 KiB) Viewed %hu times<br>\n",n+1190);
			fputs("<img src=\"/img/redunbot.jpg\" alt=\"I told U was redundant. Y U no believe me?\" border=\"1\"><br>\n",stdout);
			printf("redunbot.jpg (83.88 KiB) Viewed %hu times<br>\n",n+1190);
		}
	}
	
	fputs("</form></div></body></html>\n",stdout);
	
	return 0;
}